## A* search algorithm ##
In computer science, A* (pronounced as "A star") is a computer algorithm that is widely used in pathfinding and graph traversal, the process of plotting an efficiently directed path between multiple points, called nodes. It enjoys widespread use due to its performance and accuracy (from Wikipedia).

### Usage ###

#### Import package (path to node_modules) ####
```
import * as AStar from './node_modules/AStar/main';
```
#### Create an A* finder instance and a grid instance in your class ####
```
private m_aStarInstance: AStar.AStarFinder;
private m_grid: AStar.Grid;
```

#### Set start and end position ####
```
let startPosition = [0, 0];
let endPosition = [59, 59];
```

#### Load up your matrix (0 = walkable; 1 = not walkable) ####

Using an array (f.e. loaded up from Tilemap-Editor)
```
let matrix = [
  [0, 0, 0, 0, 0, 0, 0, 0],
  [0, 0, 0, 0, 0, 0, 0, 1],
  [0, 0, 1, 1, 0, 1, 1, 0],
  [0, 0, 1, 0, 0, 0, 1, 0],
  [0, 0, 0, 0, 0, 0, 1, 0],
  [1, 1, 1, 0, 1, 0, 1, 0],
  [0, 0, 0, 0, 1, 0, 1, 0],
  [0, 0, 1, 0, 0, 0, 0, 0]
];

this.m_grid = new AStar.Grid(matrix);
```

or randomly generated array from width and height

```
let width = 10;
let height = 10;

this.m_grid = new AStar.Grid(width, height);
```

#### Set-up your instance and return the path ####

```
this.m_aStarInstance = new AStar.AStarFinder(this.m_grid, true);
this.m_pathway = this.m_aStarInstance.findPath(startPosition, endPosition);

```

### Documentation ###
